#include "KMotionDef.h"

// Defines axis 0, 1, 2 as simple step dir TTL outputs for KSTEP
// enables them
// sets them as an xyz coordinate system for GCode

int main() 
{
	double Tau;
	int i;
	
	FPGA(STEP_PULSE_LENGTH_ADD) = 63 + 0x80;  // set polarity and pulse length to 4us
	
	ch0->InputMode=NO_INPUT_MODE;
	ch0->OutputMode=STEP_DIR_MODE;
	ch0->Vel=40000;
	ch0->Accel=200000;
	ch0->Jerk=4e+006;
	ch0->P=0;
	ch0->I=0.01;
	ch0->D=0;
	ch0->FFAccel=0;
	ch0->FFVel=0;
	ch0->MaxI=200;
	ch0->MaxErr=1e+006;
	ch0->MaxOutput=200;
	ch0->DeadBandGain=1;
	ch0->DeadBandRange=0;
	ch0->InputChan0=0;
	ch0->InputChan1=0;
	ch0->OutputChan0=8;
	ch0->OutputChan1=0;
	ch0->MasterAxis=-1;
	ch0->LimitSwitchOptions=0x0;
	ch0->InputGain0=1;
	ch0->InputGain1=1;
	ch0->InputOffset0=0;
	ch0->InputOffset1=0;
	ch0->OutputGain=1;
	ch0->OutputOffset=0;
	ch0->SlaveGain=1;
	ch0->BacklashMode=BACKLASH_OFF;
	ch0->BacklashAmount=0;
	ch0->BacklashRate=0;
	ch0->invDistPerCycle=1;
	ch0->Lead=0;
	ch0->MaxFollowingError=1000000000;
	ch0->StepperAmplitude=20;

	ch0->iir[0].B0=1;
	ch0->iir[0].B1=0;
	ch0->iir[0].B2=0;
	ch0->iir[0].A1=0;
	ch0->iir[0].A2=0;

	ch0->iir[1].B0=1;
	ch0->iir[1].B1=0;
	ch0->iir[1].B2=0;
	ch0->iir[1].A1=0;
	ch0->iir[1].A2=0;

	ch0->iir[2].B0=0.000769;
	ch0->iir[2].B1=0.001538;
	ch0->iir[2].B2=0.000769;
	ch0->iir[2].A1=1.92076;
	ch0->iir[2].A2=-0.923833;
    EnableAxisDest(0,0);

	ch1->InputMode=NO_INPUT_MODE;
	ch1->OutputMode=STEP_DIR_MODE;
	ch1->Vel=40000;
	ch1->Accel=200000;
	ch1->Jerk=4e+006;
	ch1->P=0;
	ch1->I=0.01;
	ch1->D=0;
	ch1->FFAccel=0;
	ch1->FFVel=0;
	ch1->MaxI=200;
	ch1->MaxErr=1e+006;
	ch1->MaxOutput=200;
	ch1->DeadBandGain=1;
	ch1->DeadBandRange=0;
	ch1->InputChan0=0;
	ch1->InputChan1=0;
	ch1->OutputChan0=9;
	ch1->OutputChan1=0;
	ch1->MasterAxis=-1;
	ch1->LimitSwitchOptions=0x0;
	ch1->InputGain0=1;
	ch1->InputGain1=1;
	ch1->InputOffset0=0;
	ch1->InputOffset1=0;
	ch1->OutputGain=1;
	ch1->OutputOffset=0;
	ch1->SlaveGain=1;
	ch1->BacklashMode=BACKLASH_OFF;
	ch1->BacklashAmount=0;
	ch1->BacklashRate=0;
	ch1->invDistPerCycle=1;
	ch1->Lead=0;
	ch1->MaxFollowingError=1000000000;
	ch1->StepperAmplitude=20;

	ch1->iir[0].B0=1;
	ch1->iir[0].B1=0;
	ch1->iir[0].B2=0;
	ch1->iir[0].A1=0;
	ch1->iir[0].A2=0;

	ch1->iir[1].B0=1;
	ch1->iir[1].B1=0;
	ch1->iir[1].B2=0;
	ch1->iir[1].A1=0;
	ch1->iir[1].A2=0;

	ch1->iir[2].B0=0.000769;
	ch1->iir[2].B1=0.001538;
	ch1->iir[2].B2=0.000769;
	ch1->iir[2].A1=1.92076;
	ch1->iir[2].A2=-0.923833;
    EnableAxisDest(1,0);

	ch2->InputMode=NO_INPUT_MODE;
	ch2->OutputMode=STEP_DIR_MODE;
	ch2->Vel=40000;
	ch2->Accel=200000;
	ch2->Jerk=4e+006;
	ch2->P=0;
	ch2->I=0.01;
	ch2->D=0;
	ch2->FFAccel=0;
	ch2->FFVel=0;
	ch2->MaxI=200;
	ch2->MaxErr=1e+006;
	ch2->MaxOutput=200;
	ch2->DeadBandGain=1;
	ch2->DeadBandRange=0;
	ch2->InputChan0=0;
	ch2->InputChan1=0;
	ch2->OutputChan0=10;
	ch2->OutputChan1=0;
	ch2->MasterAxis=-1;
	ch2->LimitSwitchOptions=0x0;
	ch2->InputGain0=1;
	ch2->InputGain1=1;
	ch2->InputOffset0=0;
	ch2->InputOffset1=0;
	ch2->OutputGain=-1;
	ch2->OutputOffset=0;
	ch2->SlaveGain=1;
	ch2->BacklashMode=BACKLASH_OFF;
	ch2->BacklashAmount=0;
	ch2->BacklashRate=0;
	ch2->invDistPerCycle=1;
	ch2->Lead=0;
	ch2->MaxFollowingError=1000000000;
	ch2->StepperAmplitude=20;

	ch2->iir[0].B0=1;
	ch2->iir[0].B1=0;
	ch2->iir[0].B2=0;
	ch2->iir[0].A1=0;
	ch2->iir[0].A2=0;

	ch2->iir[1].B0=1;
	ch2->iir[1].B1=0;
	ch2->iir[1].B2=0;
	ch2->iir[1].A1=0;
	ch2->iir[1].A2=0;

	ch2->iir[2].B0=1;
	ch2->iir[2].B1=0;
	ch2->iir[2].B2=0;
	ch2->iir[2].A1=0;
	ch2->iir[2].A2=0;
	EnableAxisDest(2,0);
	
	ch3->InputMode=NO_INPUT_MODE;
	ch3->OutputMode=STEP_DIR_MODE;
	ch3->Vel=4000;
	ch3->Accel=400000;
	ch3->Jerk=4e+006;
	ch3->P=0;
	ch3->I=0.01;
	ch3->D=0;
	ch3->FFAccel=0;
	ch3->FFVel=0;
	ch3->MaxI=200;
	ch3->MaxErr=1e+006;
	ch3->MaxOutput=200;
	ch3->DeadBandGain=1;
	ch3->DeadBandRange=0;
	ch3->InputChan0=0;
	ch3->InputChan1=0;
	ch3->OutputChan0=11;
	ch3->OutputChan1=0;
	ch3->MasterAxis=-1;
	ch3->LimitSwitchOptions=0x0;
	ch3->InputGain0=1;
	ch3->InputGain1=1;
	ch3->InputOffset0=0;
	ch3->InputOffset1=0;
	ch3->OutputGain=1;
	ch3->OutputOffset=0;
	ch3->SlaveGain=1;
	ch3->BacklashMode=BACKLASH_OFF;
	ch3->BacklashAmount=0;
	ch3->BacklashRate=0;
	ch3->invDistPerCycle=1;
	ch3->Lead=0;
	ch3->MaxFollowingError=1000000000;
	ch3->StepperAmplitude=20;

	ch3->iir[0].B0=1;
	ch3->iir[0].B1=0;
	ch3->iir[0].B2=0;
	ch3->iir[0].A1=0;
	ch3->iir[0].A2=0;

	ch3->iir[1].B0=1;
	ch3->iir[1].B1=0;
	ch3->iir[1].B2=0;
	ch3->iir[1].A1=0;
	ch3->iir[1].A2=0;

	ch3->iir[2].B0=0.000769;
	ch3->iir[2].B1=0.001538;
	ch3->iir[2].B2=0.000769;
	ch3->iir[2].A1=1.92076;
	ch3->iir[2].A2=-0.923833;
	EnableAxisDest(3,0);

	ch4->InputMode=NO_INPUT_MODE;
	ch4->OutputMode=STEP_DIR_MODE;
	ch4->Vel=4000;
	ch4->Accel=400000;
	ch4->Jerk=4e+006;
	ch4->P=0;
	ch4->I=0.01;
	ch4->D=0;
	ch4->FFAccel=0;
	ch4->FFVel=0;
	ch4->MaxI=200;
	ch4->MaxErr=1e+006;
	ch4->MaxOutput=200;
	ch4->DeadBandGain=1;
	ch4->DeadBandRange=0;
	ch4->InputChan0=0;
	ch4->InputChan1=0;
	ch4->OutputChan0=12;
	ch4->OutputChan1=0;
	ch4->MasterAxis=-1;
	ch4->LimitSwitchOptions=0x0;
	ch4->SoftLimitPos=1e+009;
	ch4->SoftLimitNeg=-1e+009;
	ch4->InputGain0=1;
	ch4->InputGain1=1;
	ch4->InputOffset0=0;
	ch4->InputOffset1=0;
	ch4->OutputGain=1;
	ch4->OutputOffset=0;
	ch4->SlaveGain=1;
	ch4->BacklashMode=BACKLASH_OFF;
	ch4->BacklashAmount=0;
	ch4->BacklashRate=0;
	ch4->invDistPerCycle=1;
	ch4->Lead=0;
	ch4->MaxFollowingError=1000000000;
	ch4->StepperAmplitude=20;

	ch4->iir[0].B0=1;
	ch4->iir[0].B1=0;
	ch4->iir[0].B2=0;
	ch4->iir[0].A1=0;
	ch4->iir[0].A2=0;

	ch4->iir[1].B0=1;
	ch4->iir[1].B1=0;
	ch4->iir[1].B2=0;
	ch4->iir[1].A1=0;
	ch4->iir[1].A2=0;

	ch4->iir[2].B0=0.000769;
	ch4->iir[2].B1=0.001538;
	ch4->iir[2].B2=0.000769;
	ch4->iir[2].A1=1.92076;
	ch4->iir[2].A2=-0.923833;
	EnableAxisDest(4,0);

	ch5->InputMode=NO_INPUT_MODE;
	ch5->OutputMode=STEP_DIR_MODE;
	ch5->Vel=4000;
	ch5->Accel=400000;
	ch5->Jerk=4e+006;
	ch5->P=0;
	ch5->I=0.01;
	ch5->D=0;
	ch5->FFAccel=0;
	ch5->FFVel=0;
	ch5->MaxI=200;
	ch5->MaxErr=1e+006;
	ch5->MaxOutput=200;
	ch5->DeadBandGain=1;
	ch5->DeadBandRange=0;
	ch5->InputChan0=0;
	ch5->InputChan1=0;
	ch5->OutputChan0=13;
	ch5->OutputChan1=0;
	ch5->MasterAxis=-1;
	ch5->LimitSwitchOptions=0x0;
	ch5->SoftLimitPos=1e+009;
	ch5->SoftLimitNeg=-1e+009;
	ch5->InputGain0=1;
	ch5->InputGain1=1;
	ch5->InputOffset0=0;
	ch5->InputOffset1=0;
	ch5->OutputGain=1;
	ch5->OutputOffset=0;
	ch5->SlaveGain=1;
	ch5->BacklashMode=BACKLASH_OFF;
	ch5->BacklashAmount=0;
	ch5->BacklashRate=0;
	ch5->invDistPerCycle=1;
	ch5->Lead=0;
	ch5->MaxFollowingError=1000000000;
	ch5->StepperAmplitude=20;

	ch5->iir[0].B0=1;
	ch5->iir[0].B1=0;
	ch5->iir[0].B2=0;
	ch5->iir[0].A1=0;
	ch5->iir[0].A2=0;

	ch5->iir[1].B0=1;
	ch5->iir[1].B1=0;
	ch5->iir[1].B2=0;
	ch5->iir[1].A1=0;
	ch5->iir[1].A2=0;

	ch5->iir[2].B0=0.000769;
	ch5->iir[2].B1=0.001538;
	ch5->iir[2].B2=0.000769;
	ch5->iir[2].A1=1.92076;
	ch5->iir[2].A2=-0.923833;
	EnableAxisDest(5,0);

	ch6->InputMode=NO_INPUT_MODE;
	ch6->OutputMode=STEP_DIR_MODE;
	ch6->Vel=4000;
	ch6->Accel=400000;
	ch6->Jerk=4e+006;
	ch6->P=0;
	ch6->I=0.01;
	ch6->D=0;
	ch6->FFAccel=0;
	ch6->FFVel=0;
	ch6->MaxI=200;
	ch6->MaxErr=1e+006;
	ch6->MaxOutput=200;
	ch6->DeadBandGain=1;
	ch6->DeadBandRange=0;
	ch6->InputChan0=0;
	ch6->InputChan1=0;
	ch6->OutputChan0=14;
	ch6->OutputChan1=0;
	ch6->MasterAxis=-1;
	ch6->LimitSwitchOptions=0x0;
	ch6->SoftLimitPos=1e+009;
	ch6->SoftLimitNeg=-1e+009;
	ch6->InputGain0=1;
	ch6->InputGain1=1;
	ch6->InputOffset0=0;
	ch6->InputOffset1=0;
	ch6->OutputGain=1;
	ch6->OutputOffset=0;
	ch6->SlaveGain=1;
	ch6->BacklashMode=BACKLASH_OFF;
	ch6->BacklashAmount=0;
	ch6->BacklashRate=0;
	ch6->invDistPerCycle=1;
	ch6->Lead=0;
	ch6->MaxFollowingError=1000000000;
	ch6->StepperAmplitude=20;

	ch6->iir[0].B0=1;
	ch6->iir[0].B1=0;
	ch6->iir[0].B2=0;
	ch6->iir[0].A1=0;
	ch6->iir[0].A2=0;

	ch6->iir[1].B0=1;
	ch6->iir[1].B1=0;
	ch6->iir[1].B2=0;
	ch6->iir[1].A1=0;
	ch6->iir[1].A2=0;

	ch6->iir[2].B0=0.000769;
	ch6->iir[2].B1=0.001538;
	ch6->iir[2].B2=0.000769;
	ch6->iir[2].A1=1.92076;
	ch6->iir[2].A2=-0.923833;
	EnableAxisDest(6,0);

	ch7->InputMode=NO_INPUT_MODE;
	ch7->OutputMode=STEP_DIR_MODE;
	ch7->Vel=4000;
	ch7->Accel=400000;
	ch7->Jerk=4e+006;
	ch7->P=0;
	ch7->I=0.01;
	ch7->D=0;
	ch7->FFAccel=0;
	ch7->FFVel=0;
	ch7->MaxI=200;
	ch7->MaxErr=1e+006;
	ch7->MaxOutput=200;
	ch7->DeadBandGain=1;
	ch7->DeadBandRange=0;
	ch7->InputChan0=0;
	ch7->InputChan1=0;
	ch7->OutputChan0=15;
	ch7->OutputChan1=0;
	ch7->MasterAxis=-1;
	ch7->LimitSwitchOptions=0x0;
	ch7->SoftLimitPos=1e+009;
	ch7->SoftLimitNeg=-1e+009;
	ch7->InputGain0=1;
	ch7->InputGain1=1;
	ch7->InputOffset0=0;
	ch7->InputOffset1=0;
	ch7->OutputGain=1;
	ch7->OutputOffset=0;
	ch7->SlaveGain=1;
	ch7->BacklashMode=BACKLASH_OFF;
	ch7->BacklashAmount=0;
	ch7->BacklashRate=0;
	ch7->invDistPerCycle=1;
	ch7->Lead=0;
	ch7->MaxFollowingError=1000000000;
	ch7->StepperAmplitude=20;

	ch7->iir[0].B0=1;
	ch7->iir[0].B1=0;
	ch7->iir[0].B2=0;
	ch7->iir[0].A1=0;
	ch7->iir[0].A2=0;

	ch7->iir[1].B0=1;
	ch7->iir[1].B1=0;
	ch7->iir[1].B2=0;
	ch7->iir[1].A1=0;
	ch7->iir[1].A2=0;

	ch7->iir[2].B0=0.000769;
	ch7->iir[2].B1=0.001538;
	ch7->iir[2].B2=0.000769;
	ch7->iir[2].A1=1.92076;
	ch7->iir[2].A2=-0.923833;
	EnableAxisDest(7,0);

	ch8->InputMode=NO_INPUT_MODE;
	ch8->OutputMode=STEP_DIR_MODE;
	ch8->Vel=4000;
	ch8->Accel=400000;
	ch8->Jerk=4e+006;
	ch8->P=0;
	ch8->I=0.01;
	ch8->D=0;
	ch8->FFAccel=0;
	ch8->FFVel=0;
	ch8->MaxI=200;
	ch8->MaxErr=1e+006;
	ch8->MaxOutput=200;
	ch8->DeadBandGain=1;
	ch8->DeadBandRange=0;
	ch8->InputChan0=0;
	ch8->InputChan1=0;
	ch8->OutputChan0=192;
	ch8->OutputChan1=0;
	ch8->MasterAxis=-1;
	ch8->LimitSwitchOptions=0x0;
	ch8->SoftLimitPos=1e+009;
	ch8->SoftLimitNeg=-1e+009;
	ch8->InputGain0=1;
	ch8->InputGain1=1;
	ch8->InputOffset0=0;
	ch8->InputOffset1=0;
	ch8->OutputGain=1;
	ch8->OutputOffset=0;
	ch8->SlaveGain=1;
	ch8->BacklashMode=BACKLASH_OFF;
	ch8->BacklashAmount=0;
	ch8->BacklashRate=0;
	ch8->invDistPerCycle=1;
	ch8->Lead=0;
	ch8->MaxFollowingError=1000000000;
	ch8->StepperAmplitude=20;

	ch8->iir[0].B0=1;
	ch8->iir[0].B1=0;
	ch8->iir[0].B2=0;
	ch8->iir[0].A1=0;
	ch8->iir[0].A2=0;

	ch8->iir[1].B0=1;
	ch8->iir[1].B1=0;
	ch8->iir[1].B2=0;
	ch8->iir[1].A1=0;
	ch8->iir[1].A2=0;

	ch8->iir[2].B0=0.000769;
	ch8->iir[2].B1=0.001538;
	ch8->iir[2].B2=0.000769;
	ch8->iir[2].A1=1.92076;
	ch8->iir[2].A2=-0.923833;
	EnableAxisDest(8,0);

	ch9->InputMode=NO_INPUT_MODE;
	ch9->OutputMode=STEP_DIR_MODE;
	ch9->Vel=4000;
	ch9->Accel=400000;
	ch9->Jerk=4e+006;
	ch9->P=0;
	ch9->I=0.01;
	ch9->D=0;
	ch9->FFAccel=0;
	ch9->FFVel=0;
	ch9->MaxI=200;
	ch9->MaxErr=1e+006;
	ch9->MaxOutput=200;
	ch9->DeadBandGain=1;
	ch9->DeadBandRange=0;
	ch9->InputChan0=0;
	ch9->InputChan1=0;
	ch9->OutputChan0=193;
	ch9->OutputChan1=0;
	ch9->MasterAxis=-1;
	ch9->LimitSwitchOptions=0x0;
	ch9->SoftLimitPos=1e+009;
	ch9->SoftLimitNeg=-1e+009;
	ch9->InputGain0=1;
	ch9->InputGain1=1;
	ch9->InputOffset0=0;
	ch9->InputOffset1=0;
	ch9->OutputGain=1;
	ch9->OutputOffset=0;
	ch9->SlaveGain=1;
	ch9->BacklashMode=BACKLASH_OFF;
	ch9->BacklashAmount=0;
	ch9->BacklashRate=0;
	ch9->invDistPerCycle=1;
	ch9->Lead=0;
	ch9->MaxFollowingError=1000000000;
	ch9->StepperAmplitude=20;

	ch9->iir[0].B0=1;
	ch9->iir[0].B1=0;
	ch9->iir[0].B2=0;
	ch9->iir[0].A1=0;
	ch9->iir[0].A2=0;

	ch9->iir[1].B0=1;
	ch9->iir[1].B1=0;
	ch9->iir[1].B2=0;
	ch9->iir[1].A1=0;
	ch9->iir[1].A2=0;

	ch9->iir[2].B0=0.000769;
	ch9->iir[2].B1=0.001538;
	ch9->iir[2].B2=0.000769;
	ch9->iir[2].A1=1.92076;
	ch9->iir[2].A2=-0.923833;
	EnableAxisDest(9,0);

	ch10->InputMode=NO_INPUT_MODE;
	ch10->OutputMode=STEP_DIR_MODE;
	ch10->Vel=4000;
	ch10->Accel=400000;
	ch10->Jerk=4e+006;
	ch10->P=0;
	ch10->I=0.01;
	ch10->D=0;
	ch10->FFAccel=0;
	ch10->FFVel=0;
	ch10->MaxI=200;
	ch10->MaxErr=1e+006;
	ch10->MaxOutput=200;
	ch10->DeadBandGain=1;
	ch10->DeadBandRange=0;
	ch10->InputChan0=0;
	ch10->InputChan1=0;
	ch10->OutputChan0=194;
	ch10->OutputChan1=0;
	ch10->MasterAxis=-1;
	ch10->LimitSwitchOptions=0x0;
	ch10->SoftLimitPos=1e+009;
	ch10->SoftLimitNeg=-1e+009;
	ch10->InputGain0=1;
	ch10->InputGain1=1;
	ch10->InputOffset0=0;
	ch10->InputOffset1=0;
	ch10->OutputGain=1;
	ch10->OutputOffset=0;
	ch10->SlaveGain=1;
	ch10->BacklashMode=BACKLASH_OFF;
	ch10->BacklashAmount=0;
	ch10->BacklashRate=0;
	ch10->invDistPerCycle=1;
	ch10->Lead=0;
	ch10->MaxFollowingError=1000000000;
	ch10->StepperAmplitude=20;

	ch10->iir[0].B0=1;
	ch10->iir[0].B1=0;
	ch10->iir[0].B2=0;
	ch10->iir[0].A1=0;
	ch10->iir[0].A2=0;

	ch10->iir[1].B0=1;
	ch10->iir[1].B1=0;
	ch10->iir[1].B2=0;
	ch10->iir[1].A1=0;
	ch10->iir[1].A2=0;

	ch10->iir[2].B0=0.000769;
	ch10->iir[2].B1=0.001538;
	ch10->iir[2].B2=0.000769;
	ch10->iir[2].A1=1.92076;
	ch10->iir[2].A2=-0.923833;
	EnableAxisDest(10,0);

	ch11->InputMode=NO_INPUT_MODE;
	ch11->OutputMode=STEP_DIR_MODE;
	ch11->Vel=4000;
	ch11->Accel=400000;
	ch11->Jerk=4e+006;
	ch11->P=0;
	ch11->I=0.01;
	ch11->D=0;
	ch11->FFAccel=0;
	ch11->FFVel=0;
	ch11->MaxI=200;
	ch11->MaxErr=1e+006;
	ch11->MaxOutput=200;
	ch11->DeadBandGain=1;
	ch11->DeadBandRange=0;
	ch11->InputChan0=0;
	ch11->InputChan1=0;
	ch11->OutputChan0=195;
	ch11->OutputChan1=0;
	ch11->MasterAxis=-1;
	ch11->LimitSwitchOptions=0x0;
	ch11->SoftLimitPos=1e+009;
	ch11->SoftLimitNeg=-1e+009;
	ch11->InputGain0=1;
	ch11->InputGain1=1;
	ch11->InputOffset0=0;
	ch11->InputOffset1=0;
	ch11->OutputGain=1;
	ch11->OutputOffset=0;
	ch11->SlaveGain=1;
	ch11->BacklashMode=BACKLASH_OFF;
	ch11->BacklashAmount=0;
	ch11->BacklashRate=0;
	ch11->invDistPerCycle=1;
	ch11->Lead=0;
	ch11->MaxFollowingError=1000000000;
	ch11->StepperAmplitude=20;

	ch11->iir[0].B0=1;
	ch11->iir[0].B1=0;
	ch11->iir[0].B2=0;
	ch11->iir[0].A1=0;
	ch11->iir[0].A2=0;

	ch11->iir[1].B0=1;
	ch11->iir[1].B1=0;
	ch11->iir[1].B2=0;
	ch11->iir[1].A1=0;
	ch11->iir[1].A2=0;

	ch11->iir[2].B0=0.000769;
	ch11->iir[2].B1=0.001538;
	ch11->iir[2].B2=0.000769;
	ch11->iir[2].A1=1.92076;
	ch11->iir[2].A2=-0.923833;
	EnableAxisDest(11,0);

	ch12->InputMode=NO_INPUT_MODE;
	ch12->OutputMode=STEP_DIR_MODE;
	ch12->Vel=4000;
	ch12->Accel=400000;
	ch12->Jerk=4e+006;
	ch12->P=0;
	ch12->I=0.01;
	ch12->D=0;
	ch12->FFAccel=0;
	ch12->FFVel=0;
	ch12->MaxI=200;
	ch12->MaxErr=1e+006;
	ch12->MaxOutput=200;
	ch12->DeadBandGain=1;
	ch12->DeadBandRange=0;
	ch12->InputChan0=0;
	ch12->InputChan1=0;
	ch12->OutputChan0=76;
	ch12->OutputChan1=0;
	ch12->MasterAxis=-1;
	ch12->LimitSwitchOptions=0x0;
	ch12->SoftLimitPos=1e+009;
	ch12->SoftLimitNeg=-1e+009;
	ch12->InputGain0=1;
	ch12->InputGain1=1;
	ch12->InputOffset0=0;
	ch12->InputOffset1=0;
	ch12->OutputGain=1;
	ch12->OutputOffset=0;
	ch12->SlaveGain=1;
	ch12->BacklashMode=BACKLASH_OFF;
	ch12->BacklashAmount=0;
	ch12->BacklashRate=0;
	ch12->invDistPerCycle=1;
	ch12->Lead=0;
	ch12->MaxFollowingError=1000000000;
	ch12->StepperAmplitude=20;

	ch12->iir[0].B0=1;
	ch12->iir[0].B1=0;
	ch12->iir[0].B2=0;
	ch12->iir[0].A1=0;
	ch12->iir[0].A2=0;

	ch12->iir[1].B0=1;
	ch12->iir[1].B1=0;
	ch12->iir[1].B2=0;
	ch12->iir[1].A1=0;
	ch12->iir[1].A2=0;

	ch12->iir[2].B0=0.000769;
	ch12->iir[2].B1=0.001538;
	ch12->iir[2].B2=0.000769;
	ch12->iir[2].A1=1.92076;
	ch12->iir[2].A2=-0.923833;
	EnableAxisDest(12,0);

	ch13->InputMode=NO_INPUT_MODE;
	ch13->OutputMode=STEP_DIR_MODE;
	ch13->Vel=4000;
	ch13->Accel=400000;
	ch13->Jerk=4e+006;
	ch13->P=0;
	ch13->I=0.01;
	ch13->D=0;
	ch13->FFAccel=0;
	ch13->FFVel=0;
	ch13->MaxI=200;
	ch13->MaxErr=1e+006;
	ch13->MaxOutput=200;
	ch13->DeadBandGain=1;
	ch13->DeadBandRange=0;
	ch13->InputChan0=0;
	ch13->InputChan1=0;
	ch13->OutputChan0=77;
	ch13->OutputChan1=0;
	ch13->MasterAxis=-1;
	ch13->LimitSwitchOptions=0x0;
	ch13->SoftLimitPos=1e+009;
	ch13->SoftLimitNeg=-1e+009;
	ch13->InputGain0=1;
	ch13->InputGain1=1;
	ch13->InputOffset0=0;
	ch13->InputOffset1=0;
	ch13->OutputGain=1;
	ch13->OutputOffset=0;
	ch13->SlaveGain=1;
	ch13->BacklashMode=BACKLASH_OFF;
	ch13->BacklashAmount=0;
	ch13->BacklashRate=0;
	ch13->invDistPerCycle=1;
	ch13->Lead=0;
	ch13->MaxFollowingError=1000000000;
	ch13->StepperAmplitude=20;

	ch13->iir[0].B0=1;
	ch13->iir[0].B1=0;
	ch13->iir[0].B2=0;
	ch13->iir[0].A1=0;
	ch13->iir[0].A2=0;

	ch13->iir[1].B0=1;
	ch13->iir[1].B1=0;
	ch13->iir[1].B2=0;
	ch13->iir[1].A1=0;
	ch13->iir[1].A2=0;

	ch13->iir[2].B0=0.000769;
	ch13->iir[2].B1=0.001538;
	ch13->iir[2].B2=0.000769;
	ch13->iir[2].A1=1.92076;
	ch13->iir[2].A2=-0.923833;
	EnableAxisDest(13,0);

	ch14->InputMode=NO_INPUT_MODE;
	ch14->OutputMode=STEP_DIR_MODE;
	ch14->Vel=4000;
	ch14->Accel=400000;
	ch14->Jerk=4e+006;
	ch14->P=0;
	ch14->I=0.01;
	ch14->D=0;
	ch14->FFAccel=0;
	ch14->FFVel=0;
	ch14->MaxI=200;
	ch14->MaxErr=1e+006;
	ch14->MaxOutput=200;
	ch14->DeadBandGain=1;
	ch14->DeadBandRange=0;
	ch14->InputChan0=0;
	ch14->InputChan1=0;
	ch14->OutputChan0=78;
	ch14->OutputChan1=0;
	ch14->MasterAxis=-1;
	ch14->LimitSwitchOptions=0x0;
	ch14->SoftLimitPos=1e+009;
	ch14->SoftLimitNeg=-1e+009;
	ch14->InputGain0=1;
	ch14->InputGain1=1;
	ch14->InputOffset0=0;
	ch14->InputOffset1=0;
	ch14->OutputGain=1;
	ch14->OutputOffset=0;
	ch14->SlaveGain=1;
	ch14->BacklashMode=BACKLASH_OFF;
	ch14->BacklashAmount=0;
	ch14->BacklashRate=0;
	ch14->invDistPerCycle=1;
	ch14->Lead=0;
	ch14->MaxFollowingError=1000000000;
	ch14->StepperAmplitude=20;

	ch14->iir[0].B0=1;
	ch14->iir[0].B1=0;
	ch14->iir[0].B2=0;
	ch14->iir[0].A1=0;
	ch14->iir[0].A2=0;

	ch14->iir[1].B0=1;
	ch14->iir[1].B1=0;
	ch14->iir[1].B2=0;
	ch14->iir[1].A1=0;
	ch14->iir[1].A2=0;

	ch14->iir[2].B0=0.000769;
	ch14->iir[2].B1=0.001538;
	ch14->iir[2].B2=0.000769;
	ch14->iir[2].A1=1.92076;
	ch14->iir[2].A2=-0.923833;
	EnableAxisDest(14,0);


	ch15->InputMode=NO_INPUT_MODE;
	ch15->OutputMode=STEP_DIR_MODE;
	ch15->Vel=4000;
	ch15->Accel=400000;
	ch15->Jerk=4e+006;
	ch15->P=0;
	ch15->I=0.01;
	ch15->D=0;
	ch15->FFAccel=0;
	ch15->FFVel=0;
	ch15->MaxI=200;
	ch15->MaxErr=1e+006;
	ch15->MaxOutput=200;
	ch15->DeadBandGain=1;
	ch15->DeadBandRange=0;
	ch15->InputChan0=0;
	ch15->InputChan1=0;
	ch15->OutputChan0=79;
	ch15->OutputChan1=0;
	ch15->MasterAxis=-1;
	ch15->LimitSwitchOptions=0x0;
	ch15->SoftLimitPos=1e+009;
	ch15->SoftLimitNeg=-1e+009;
	ch15->InputGain0=1;
	ch15->InputGain1=1;
	ch15->InputOffset0=0;
	ch15->InputOffset1=0;
	ch15->OutputGain=1;
	ch15->OutputOffset=0;
	ch15->SlaveGain=1;
	ch15->BacklashMode=BACKLASH_OFF;
	ch15->BacklashAmount=0;
	ch15->BacklashRate=0;
	ch15->invDistPerCycle=1;
	ch15->Lead=0;
	ch15->MaxFollowingError=1000000000;
	ch15->StepperAmplitude=20;

	ch15->iir[0].B0=1;
	ch15->iir[0].B1=0;
	ch15->iir[0].B2=0;
	ch15->iir[0].A1=0;
	ch15->iir[0].A2=0;

	ch15->iir[1].B0=1;
	ch15->iir[1].B1=0;
	ch15->iir[1].B2=0;
	ch15->iir[1].A1=0;
	ch15->iir[1].A2=0;

	ch15->iir[2].B0=0.000769;
	ch15->iir[2].B1=0.001538;
	ch15->iir[2].B2=0.000769;
	ch15->iir[2].A1=1.92076;
	ch15->iir[2].A2=-0.923833;
	EnableAxisDest(15,0);


	// define 8 axes of Coordinate System
	DefineCoordSystem8(0,1,2,3,4,5,6,7);   // X Y Z A B C U V
	
	// define 8 Prime axes of Coordinate System
	DefineCoordSystem8P(8,9,10,11,12,13,14,15); // XP YP ZP AP BP CP UP VP
	
//  Add a small amount of Coordinated Motion Path smoothing if desired
	Tau = 0.001;  // seconds for Low Pass Filter Time Constant
	KLP = exp(-TIMEBASE/Tau);
//	KLP=0; // force to 0 to disable
//	printf("Tau=%f KLP=%f\n",Tau,KLP);

	for (i=0; i<16; i++)
	{
		Move(i,10);
		while (!CheckDone(i)) ;
		Move(i,0);
	}

	return 0;
}
